<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_121) on Sat Mar 18 22:03:29 ADT 2017 -->
<title>Heap</title>
<meta name="date" content="2017-03-18">
<link rel="stylesheet" type="text/css" href="../stylesheet.css" title="Style">
<script type="text/javascript" src="../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Heap";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Heap.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../HeapClasses/MinHeap.html" title="class in HeapClasses"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../index.html?HeapClasses/Heap.html" target="_top">Frames</a></li>
<li><a href="Heap.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">HeapClasses</div>
<h2 title="Class Heap" class="title">Class Heap&lt;T extends java.lang.Comparable&lt;T&gt;&gt;</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>HeapClasses.Heap&lt;T&gt;</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - Type of data stored in the heap, must implement method compareTo of
                                generic Comparable<T> interface, to compare priorities.</dd>
</dl>
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../Interfaces/AbstractMaxHeap.html" title="interface in Interfaces">AbstractMaxHeap</a>&lt;T&gt;</dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">Heap&lt;T extends java.lang.Comparable&lt;T&gt;&gt;</span>
extends java.lang.Object
implements <a href="../Interfaces/AbstractMaxHeap.html" title="interface in Interfaces">AbstractMaxHeap</a>&lt;T&gt;</pre>
<div class="block">This class implements a generic max heap.</div>
<dl>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Sesh Venugopal</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../HeapClasses/Heap.html#Heap--">Heap</a></span>()</code>
<div class="block">Initializes a new instance by setting up storage of default initial capacity.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../HeapClasses/Heap.html#Heap-int-">Heap</a></span>(int&nbsp;cap)</code>
<div class="block">Initializes a new instance by setting up storage of given capacity.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../HeapClasses/Heap.html#add-T-">add</a></span>(<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a>&nbsp;item)</code>
<div class="block">Adds the given item to this heap.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../HeapClasses/Heap.html#clear--">clear</a></span>()</code>
<div class="block">Empties this heap by removing all items.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../HeapClasses/Heap.html#deleteMax--">deleteMax</a></span>()</code>
<div class="block">Removes the maximum-priority (top) item of this heap.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code><a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../HeapClasses/Heap.html#first--">first</a></span>()</code>
<div class="block">Returns the first item in this heap, and sets the iteration cursor to the 
 first position.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../HeapClasses/Heap.html#isEmpty--">isEmpty</a></span>()</code>
<div class="block">Tells whether this heap is empty or not.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../HeapClasses/Heap.html#next--">next</a></span>()</code>
<div class="block">Sets the cursor to the next position, and returns the item in this heap at
 that position.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../HeapClasses/Heap.html#size--">size</a></span>()</code>
<div class="block">Returns the number of items in this heap.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Heap-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>Heap</h4>
<pre>public&nbsp;Heap(int&nbsp;cap)</pre>
<div class="block">Initializes a new instance by setting up storage of given capacity.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>cap</code> - Initial storage capacity.</dd>
</dl>
</li>
</ul>
<a name="Heap--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Heap</h4>
<pre>public&nbsp;Heap()</pre>
<div class="block">Initializes a new instance by setting up storage of default initial capacity.</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="add-java.lang.Comparable-">
<!--   -->
</a><a name="add-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>add</h4>
<pre>public&nbsp;void&nbsp;add(<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a>&nbsp;item)</pre>
<div class="block">Adds the given item to this heap.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Interfaces/AbstractMaxHeap.html#add-T-">add</a></code>&nbsp;in interface&nbsp;<code><a href="../Interfaces/AbstractMaxHeap.html" title="interface in Interfaces">AbstractMaxHeap</a>&lt;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a> extends java.lang.Comparable&lt;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a>&gt;&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>item</code> - Item to be added.</dd>
</dl>
</li>
</ul>
<a name="deleteMax--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>deleteMax</h4>
<pre>public&nbsp;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a>&nbsp;deleteMax()</pre>
<div class="block">Removes the maximum-priority (top) item of this heap.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Interfaces/AbstractMaxHeap.html#deleteMax--">deleteMax</a></code>&nbsp;in interface&nbsp;<code><a href="../Interfaces/AbstractMaxHeap.html" title="interface in Interfaces">AbstractMaxHeap</a>&lt;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a> extends java.lang.Comparable&lt;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a>&gt;&gt;</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Removed item.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.util.NoSuchElementException</code> - If this heap is empty.</dd>
</dl>
</li>
</ul>
<a name="clear--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clear</h4>
<pre>public&nbsp;void&nbsp;clear()</pre>
<div class="block">Empties this heap by removing all items.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Interfaces/AbstractMaxHeap.html#clear--">clear</a></code>&nbsp;in interface&nbsp;<code><a href="../Interfaces/AbstractMaxHeap.html" title="interface in Interfaces">AbstractMaxHeap</a>&lt;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a> extends java.lang.Comparable&lt;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a>&gt;&gt;</code></dd>
</dl>
</li>
</ul>
<a name="size--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>size</h4>
<pre>public&nbsp;int&nbsp;size()</pre>
<div class="block">Returns the number of items in this heap.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Number of items in this heap.</dd>
</dl>
</li>
</ul>
<a name="isEmpty--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isEmpty</h4>
<pre>public&nbsp;boolean&nbsp;isEmpty()</pre>
<div class="block">Tells whether this heap is empty or not.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>True if this heap is empty, false otherwise.</dd>
</dl>
</li>
</ul>
<a name="first--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>first</h4>
<pre>public&nbsp;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a>&nbsp;first()</pre>
<div class="block">Returns the first item in this heap, and sets the iteration cursor to the 
 first position.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Interfaces/AbstractMaxHeap.html#first--">first</a></code>&nbsp;in interface&nbsp;<code><a href="../Interfaces/AbstractMaxHeap.html" title="interface in Interfaces">AbstractMaxHeap</a>&lt;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a> extends java.lang.Comparable&lt;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a>&gt;&gt;</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>First item in this heap, null if list is empty.</dd>
</dl>
</li>
</ul>
<a name="next--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>next</h4>
<pre>public&nbsp;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a>&nbsp;next()</pre>
<div class="block">Sets the cursor to the next position, and returns the item in this heap at
 that position. <br> To iterate over this heap, there
 must be a call to first( ), followed by successive calls to next( ). Iteration
 is in level-order sequence.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../Interfaces/AbstractMaxHeap.html#next--">next</a></code>&nbsp;in interface&nbsp;<code><a href="../Interfaces/AbstractMaxHeap.html" title="interface in Interfaces">AbstractMaxHeap</a>&lt;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a> extends java.lang.Comparable&lt;<a href="../HeapClasses/Heap.html" title="type parameter in Heap">T</a>&gt;&gt;</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Next item in this heap. Null if heap is empty, or cursor is at the 
         end of the heap at the time this method is called, i.e. end of heap was
         reached.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Heap.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../HeapClasses/MinHeap.html" title="class in HeapClasses"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../index.html?HeapClasses/Heap.html" target="_top">Frames</a></li>
<li><a href="Heap.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
